function YpmPopup() {

	this.ypmCount = 0;
	this.popupData = [];
	this.popupId = 0;
}

YpmPopup.prototype.setPopupData = function(popupData) {

	popupData = this.filterPopupData(popupData);
	this.popupData = popupData;
};

YpmPopup.prototype.getPopupData = function() {

	return this.popupData;
};

YpmPopup.prototype.setPopupId = function(popupId) {

	this.popupId = popupId;
};

YpmPopup.prototype.getPopupId = function() {

	return this.popupId;
};

YpmPopup.prototype.varToBool = function (optionName) {

	var returnValue = (optionName) ? true : false;
	return returnValue;
};

YpmPopup.prototype.init = function () {

	var that = this;
	jQuery(".ypm-open-popup").each(function () {
		var currentPopup = jQuery(this);
		var popupEvent = jQuery(this).attr("data-popup-event");
		if (typeof popupEvent == 'undefined') {
			popupEvent = 'click';
		}

		that.ypmCount = 0;
		var callBack = function () {

			that.ypmCount += 1;
			var status = that.ypmCount > 1;
			if (status) {
				return;
			}
			var popupId = currentPopup.attr("data-ypm-popup-id");
			var data = YPM_DATA[popupId];
			if(typeof data == 'undefined') {
				return false;
			}
			that.setPopupId(popupId);
			that.setPopupData(data);
			that.openPopup();
		};

		if (popupEvent == 'click') {
			jQuery(this).bind(popupEvent, function () {
				callBack();
			});
		}
		else if (popupEvent == 'hover') {
			jQuery(this).hover(function () {
				callBack();
			}, function () {
				
			});
		}

	});
};

YpmPopup.prototype.customEvents = function() {
	
	var data = this.getPopupData();

	jQuery('#yrmcolorbox').on('yrmOnOpen', function() {
		
	});
};

YpmPopup.prototype.openByPopupEvent = function() {

	var popupId = this.getPopupId();
	
	if(typeof YPM_DATA[popupId] == 'undefined') {
		return;
	}
	var data = YPM_DATA[popupId];
	this.setPopupData(data);

	if(typeof data['ypm-popup-exit-enable'] != 'undefined' && data['ypm-popup-exit-enable'] == 'on') {
		YpmPopup.prototype = new YpmExit();
	}
	else {
		this.onLoad();
	}
};

YpmPopup.prototype.openPopup = function (popupId) {

	this.setPopupId(popupId);

	this.openByPopupEvent();
};

YpmPopup.prototype.onLoad = function() {

	var data = this.getPopupData();
	var that = this;

	var isAllowToLoad = that.allowToLoad();
	if (!isAllowToLoad) return isAllowToLoad;

	setTimeout(function () {
		that.openPopup();

	}, data['ypm-delay']*1000);
};

YpmPopup.prototype.allowToLoad = function() {
	var popupHasLimit = this.isSatisfyForShowingLimitation();
	if (!popupHasLimit) {
		return popupHasLimit;
	}

	return true;
};

YpmPopup.prototype.isSatisfyForShowingLimitation = function()
{
	var data = this.getPopupData();
	var popupLimitation = data['ypm-popup-showing-limitation'];

	if (!popupLimitation) {
		return true;
	}

	var cookieData = this.getPopupShowLimitationCookie();

	/*when there is not*/
	if (!cookieData.cookie) {
		return true;
	}
};

YpmPopup.prototype.getPopupShowLimitationCookie = function()
{
	var savedCookie = this.getPopupShowLimitationCookieDetails();
	savedCookie = this.filterPopupLimitationCookie(savedCookie);

	return savedCookie;
};

YpmPopup.prototype.filterPopupLimitationCookie = function(cookie)
{
	var result = {};
	result.cookie = '';
	if (cookie.isPageLevel) {

		result.cookieName = cookie.pageLevelCookieName;
		if (cookie.pageLevelCookie) {
			result.cookie = jQuery.parseJSON(cookie.pageLevelCookie);
		}

		YpmPopup.deleteCookie(cookie.domainLevelCookieName);

		return result;
	}
	result.cookieName = cookie.domainLevelCookieName;
	if (cookie.domainLevelCookie) {
		result.cookie = jQuery.parseJSON(cookie.domainLevelCookie);
	}
	var currentUrl = window.location.href;

	YpmPopup.deleteCookie(cookie.pageLevelCookieName, currentUrl);

	return result;
};

YpmPopup.prototype.getPopupShowLimitationCookieDetails = function()
{
	var result = false;
	var data = this.getPopupData();
	var currentUrl = window.location.href;
	var currentPopupId = this.getPopupId();

	/*Cookie names*/
	var popupLimitationCookieHomePageLevelName = 'YPMShowingLimitationHomePage' + currentPopupId;
	var popupLimitationCookiePageLevelName = 'YPMShowingLimitationPage' + currentPopupId;
	var popupLimitationCookieDomainName = 'YPMShowingLimitationDomain' + currentPopupId;

	var pageLevelCookie = data['ypm-show-popup-same-user-page-level'] || false;

	/*check if current url is home page*/
	if (currentUrl === YpmParams.homePageUrl) {
		popupLimitationCookiePageLevelName = popupLimitationCookieHomePageLevelName;
	}
	var popupLimitationPageLevelCookie = YpmPopup.getCookie(popupLimitationCookiePageLevelName);
	var popupLimitationDomainCookie = YpmPopup.getCookie(popupLimitationCookieDomainName);

	result = {
		'pageLevelCookieName': popupLimitationCookiePageLevelName,
		'domainLevelCookieName': popupLimitationCookieDomainName,
		'pageLevelCookie': popupLimitationPageLevelCookie,
		'domainLevelCookie': popupLimitationDomainCookie,
		'isPageLevel': pageLevelCookie
	};

	return result;
};

YpmPopup.prototype.openPopup = function () {

	this.popupEvents();
	var popupId = this.getPopupId();
	var data = this.getPopupData();

	var href = '#ypm-popup-content-wrapper-'+popupId;
	var that = this;

	var title = data['title'];
	var showTitle = this.varToBool(data['ypm-popup-title']);
	if(!showTitle) {
		title = false;
	}
	var width = data['ypm-popup-width'];
	var height = data['ypm-popup-height'];
	var maxWidth = data['ypm-popup-max-width'];
	var maxHeight = data['ypm-popup-max-height'];
	var theme = data['ypm-popup-theme'];
	var ypmOverlayOpacity = data['ypm-overlay-opacity'];
	var escKey = this.varToBool(data['ypm-esc-key']);
	var closeButton = this.varToBool(data['ypm-close-button']);
	var overlayClick = this.varToBool(data['ypm-overlay-click']);
	var content = data['content'];
	var initialWidth = 300;
	var initialHeight = 100;
	var positionsObj = this.getPositionData(data);

	var YrmConfig = {
		popupId: popupId,
		title: title,
		html: false,
		inline: true,
		href: href,
		closeButton: closeButton,
		overlayClose: overlayClick,
		opacity: ypmOverlayOpacity,
		className: 'yrm'+theme,
		escKey: escKey,
		fixed: positionsObj.fixed,
		top: positionsObj.top,
		bottom: positionsObj.bottom,
		left: positionsObj.left,
		right: positionsObj.right,
		overlayId: '#yrmcboxOverlay',
		onOpen: function() {
			jQuery(YrmConfig.overlayId).addClass("yrmcboxOverlayBg");
			if(data['ypm-overlay-color']) {
				jQuery('.yrmcboxOverlayBg').css({'background': 'none', 'background-color': data['ypm-overlay-color']})
			}
			if(data['ypm-content-click-status']) {
				var clickCount = 0;
				jQuery('#yrmcboxContent').bind('click', function () {
					clickCount += 1;
					if (clickCount == data['ypm-content-click-count']) {
						jQuery.yrmcolorbox.close();
					}
				});
			}
			jQuery(YrmConfig.overlayId).css('zIndex', data['ypm-z-index']);
			jQuery('#yrmcolorbox').trigger('yrmOnOpen', {popupId: popupId, data: data});
		},
		onCleanup: function () {
			that.ypmCount = 0;
			jQuery('#yrmcolorbox').trigger("yrmPopupCleanup", {popupId: popupId, data: data});
		},
		onComplete: function () {
			jQuery(window).trigger('yrmOnComplete', {popupId: popupId, data: data});
			jQuery('#yrmcolorbox').trigger('yrmOnComplete', {popupId: popupId, data: data});
		},
		onClosed: function () {
			jQuery('#yrmcolorbox').trigger("yrmPopupClose", {popupId: popupId, data: data});
		}
	};

	if(width) {
		YrmConfig.width = width;
	}
	if(height) {
		YrmConfig.height = height;
	}
	if(maxWidth) {
		YrmConfig.maxWidth = maxWidth;
	}
	if(initialWidth) {
		YrmConfig.initialWidth = initialWidth;
	}
	if(initialHeight) {
		YrmConfig.initialHeight = initialHeight;
	}

	jQuery.yrmcolorbox(YrmConfig);

	this.customEvents();
};

YpmPopup.prototype.popupEvents = function ()
{
	var that = this;
	var colorBox = jQuery('#yrmcolorbox');
	colorBox.bind('yrmOnOpen', function (e, args) {

	});

	colorBox.bind("yrmPopupCleanup", function (e, args) {

	});

	colorBox.bind("yrmOnComplete", function (e, args) {

		var data = args.data;
		var popupId = args.popupId;
		var titleColor = data['ypm-title-color'];
		var disablePageScrolling = data['ypm-disable-page-scrolling'];

		if(disablePageScrolling) {
			jQuery('body').addClass('ypm-disable-page-scrolling');
		}
		jQuery('.ypm-popup-content-'+popupId+' #yrmcboxTitle').css({color: titleColor});

		/*Popup open count*/
		that.openCount(args);
		that.setPopupLimitation(args);
	});

	colorBox.bind("yrmPopupClose", function (e, args) {

		var data = args.data;
		var disablePageScrolling = data['ypm-disable-page-scrolling'];

		if(disablePageScrolling) {
			jQuery('body').removeClass('ypm-disable-page-scrolling');
		}
	});
};

YpmPopup.prototype.openCount = function (args)
{
	var popupId = args.popupId;
	var data = {
		action: 'ypm_increment_popup_count',
		ajaxNonce: YpmParams.ajaxNonce,
		popupId: popupId
	};
	jQuery.post(YpmParams.ajaxurl, data, function(response) {
	});
};

YpmPopup.prototype.setPopupLimitation = function (args)
{
	var data = this.getPopupData();
	var cookieData = this.getPopupShowLimitationCookie();
	var cookie = cookieData.cookie || {};
	var openingCount = cookie.openingCount || 0;
	var currentUrl = window.location.href;

	if (!data['ypm-limitation-shwoing-expiration']) {
		currentUrl = '';
	}
	cookie.openingCount = openingCount + 1;
	cookie.openingPage = currentUrl;
	var popupShowingLimitExpiry = parseInt(data['ypm-limitation-shwoing-expiration']);

	YpmPopup.setCookie(cookieData.cookieName, JSON.stringify(cookie), popupShowingLimitExpiry, currentUrl);
};

YpmPopup.prototype.filterPopupData = function (popupData)
{
	if (popupData['ypm-popup-dimensions-mode'] == 'auto') {
		var width = '';
		if (popupData['ypm-popup-dimensions-auto-size'] != 'auto') {
			width = popupData['ypm-popup-dimensions-auto-size']+'%';
		}
		popupData['ypm-popup-width'] = width;
		popupData['ypm-popup-height'] = '';
	}
	return popupData;
};

YpmPopup.prototype.getPositionData = function (popupData) {
	var positions = {
		fixed: false,
		top: false,
		right: false,
		bottom: false,
		left: false,
	};

	if (!popupData['ypm-popup-location']) {
		return positions;
	}
	var position = popupData['ypm-popup-fixed-position'];

	/*The center Position*/
	positions.fixed = true;
	switch (position) {
		case "1":
			positions.left = "0px";
			positions.top = "0px";
			break;
		case "2":
			positions.top = "0px";
			break;
		case "3":
			positions.top = "0px";
			positions.right = "0px";
			break;
		case "4":
			positions.left = "0px";
			break;
		case "6":
			positions.right = "0px";
			break;
		case "7":
			positions.bottom = "0px";
			positions.left = "0px";
			break;
		case "8":
			positions.bottom = "0px";
			break;
		case "9":
			positions.bottom = "0px";
			positions.right = "0px";
			break;
	}

	return positions;
};

YpmPopup.prototype.Onload = function (eventData) {
	var that = this;
	setTimeout(function () {
        that.onLoad();
    }, parseInt(eventData['key2'])*1000)
};

/* Cookie helper start */

YpmPopup.getCookie = function (cName) {

	var name = cName + "=";
	var ca = document.cookie.split(';');
	for (var i = 0; i < ca.length; i++) {
		var c = ca[i];
		while (c.charAt(0) == ' ') {
			c = c.substring(1);
		}
		if (c.indexOf(name) == 0) {
			return c.substring(name.length, c.length);
		}
	}
	return "";
};

YpmPopup.deleteCookie = function (name) {

	document.cookie = name + '=; expires=Thu, 01 Jan 1970 00:00:01 GMT;';
};

YpmPopup.setCookie = function (cName, cValue, exDays, cPageLevel) {

	var expirationDate = new Date();
	var cookiePageLevel = '';
	var cookieExpirationData = 1;
	if (!exDays || isNaN(exDays)) {
		exDays = 365 * 50;
	}
	if (typeof cPageLevel == 'undefined') {
		cPageLevel = false;
	}
	expirationDate.setDate(expirationDate.getDate() + exDays);
	cookieExpirationData = expirationDate.toUTCString();
	var expires = 'expires='+cookieExpirationData;

	if (exDays == -1) {
		expires = '';
	}

	if (cPageLevel) {
		cookiePageLevel = 'path=/;';
	}

	var value = cValue + ((exDays == null) ? ";" : "; " + expires + ";" + cookiePageLevel);
	document.cookie = cName + "=" + value;
};


/* Cookie helper end */

jQuery(document).ready(function ($) {

	var ypmObj = new YpmPopup();
	ypmObj.init();
});