function YpmAdminJs() {

	this.enableDisable();
	this.colorpicker();
	this.accordion();
	this.upgradePro();
	this.select2();
	this.tabEvenetsListener();
	this.copySortCode();
	this.editor();

	this.livePreview();
	this.multipleChoiceButton();
	this.resetViewCount();
	this.fixedPositionSelection();
}

YpmAdminJs.prototype.copySortCode = function() {
	jQuery('.ypm-shortcode-input').bind('click', function() {
		var currentId = jQuery(this).data('id');
		var copyText = document.getElementById('ypm-shortcode-input-'+currentId);
		copyText.select();
		document.execCommand('copy');

		var tooltip = document.getElementById('ypm-tooltip-'+currentId);
		tooltip.innerHTML = YpmAdminParams.copied;
	});

	jQuery(document).on('focusout', '.countdown-shortcode',function() {
		var currentId = jQuery(this).data('id');
		var tooltip = document.getElementById('ypm-tooltip-'+currentId);
		tooltip.innerHTML = YpmAdminParams.copyToClipboard;
	});
};

YpmAdminJs.prototype.tabEvenetsListener = function() {

	if (!jQuery('.nav-tabs a').length) {
		return false;
	}

	jQuery('.nav-tabs a').bind('click', function (e) {
		e.preventDefault();
		jQuery('.nav.nav-tabs li').removeClass('active');
		jQuery(this).parent().addClass('active');
		jQuery('.tab-pane.fade').removeClass('in active');
		var id = jQuery(this).attr('href');
		jQuery(id).addClass('in active');
	});
};

YpmAdminJs.prototype.select2 = function () {
	if (!jQuery('.js-basic-select').length) {
		return false;
	}
	jQuery('.js-basic-select').select2();
};

YpmAdminJs.prototype.colorpicker = function() {

	if (!jQuery("#range").length) {
		return false;
	}
	jQuery('.ypm-color-picker').wpColorPicker();

	jQuery("#range").ionRangeSlider({
		hide_min_max: true,
		keyboard: true,
		min: 0,
		max: 1,
		type: 'single',
		step: 0.1,
		prefix: "",
		grid: true
	});
};

YpmAdminJs.prototype.accordion = function () {

	var that = this;
	var element = jQuery(".js-ypm-accordion");
	element.each(function() {
		that.checkboxAccordion(jQuery(this));
	});

	element.click(function() {
		var elements = jQuery(this);
		that.checkboxAccordion(jQuery(this));
	});
};

YpmAdminJs.prototype.checkboxAccordion = function (element) {

	if(!element.is(':checked')) {
		element.parents('.row').first().nextAll("div").first().css({'display': 'none'});
	}
	else {
		element.parents('.row').first().nextAll("div").first().css({'display':'block'});
	}
};

YpmAdminJs.prototype.upgradePro = function () {
	jQuery('.yrm-pro-options').on('click', function() {
		window.open(YpmAdminParams.proURL);
	});
};

YpmAdminJs.prototype.editor = function() {
	(function($){
		$(function(){

			if( $('#ypm-editor-js').length ) {
				var editorSettings = wp.codeEditor.defaultSettings ? _.clone( wp.codeEditor.defaultSettings ) : {};
				editorSettings.codemirror = _.extend(
					{},
					editorSettings.codemirror,
					{
						mode: 'javascript',
					}
				);
				var editor = wp.codeEditor.initialize( $('#ypm-editor-js'), editorSettings );
			}

			if( $('#ypm-editor-css').length ) {
				var editorSettings = wp.codeEditor.defaultSettings ? _.clone( wp.codeEditor.defaultSettings ) : {};
				editorSettings.codemirror = _.extend(
					{},
					editorSettings.codemirror,
					{
						indentUnit: 2,
						tabSize: 2,
						mode: 'css',
					}
				);
				var editor = wp.codeEditor.initialize( $('#ypm-editor-css'), editorSettings );
			}
		});
	})(jQuery);
};

YpmAdminJs.prototype.livePreview = function ()
{
	var previewHeader = jQuery('.ypm-live-preview-text');

	if (!previewHeader.length) {
		return false;
	}
	previewHeader.bind('click', function () {
		var toggleIcon = jQuery('.ypm-toggle-icon');
		if (toggleIcon.hasClass('ypm-toggle-icon-open')) {
			toggleIcon.removeClass('ypm-toggle-icon-open').addClass('ypm-toggle-icon-close');
		}
		else {
			toggleIcon.removeClass('ypm-toggle-icon-close').addClass('ypm-toggle-icon-open');
		}
		jQuery('.ypm-live-preview-content').toggle();
	});

};

YpmAdminJs.prototype.multipleChoiceButton = function() {
	var choiceOptions = jQuery('.ypm-choice-option-wrapper input');
	if(!choiceOptions.length) {
		return false;
	}

	var that = this;

	choiceOptions.each(function() {

		if(jQuery(this).is(':checked')) {
			that.buildChoiceShowOption(jQuery(this));
		}

		jQuery(this).on('change', function() {
			that.hideAllChoiceWrapper(jQuery(this).parents('.ypm-multichoice-wrapper').first());
			that.buildChoiceShowOption(jQuery(this));
		});
	})
};


YpmAdminJs.prototype.hideAllChoiceWrapper = function(choiceOptionsWrapper) {
	choiceOptionsWrapper.find('input').each(function() {
		var choiceInputWrapperId = jQuery(this).attr('data-attr-href');
		jQuery('#'+choiceInputWrapperId).addClass('ypm-hide');
	})
};

YpmAdminJs.prototype.buildChoiceShowOption = function(currentRadioButton)  {
	var choiceOptions = currentRadioButton.attr('data-attr-href');
	var currentOptionWrapper = currentRadioButton.parents('.ypm-choice-wrapper').first();
	var choiceOptionWrapper = jQuery('#'+choiceOptions).removeClass('ypm-hide');
	currentOptionWrapper.after(choiceOptionWrapper);
};

YpmAdminJs.prototype.resetViewCount = function()  {
	var resetButton = jQuery('.ypm-reset-count-btn');

	if (!resetButton.length) {
		return false;
	}

	resetButton.bind('click', function () {

		if (!confirm(YpmAdminParams.areYouSure)) {
			return false;
		}

		var data = {
			postId: jQuery(this).data('id'),
			action: "ypm_reset_view_count",
			nonce: YpmAdminParams.ajaxNonce
		};

		jQuery.post(ajaxurl, data, function(response) {
			window.location.reload();
		});
	});
};

YpmAdminJs.prototype.enableDisable = function()  {
	var resetButton = jQuery('.ypm-popup-enable');

	if (!resetButton.length) {
		return false;
	}

	resetButton.bind('change', function () {

		var data = {
			postId: jQuery(this).data('switch-id'),
			value: jQuery(this).is(":checked"),
			action: "ypm_change_popup_status",
			ajaxNonce: YpmAdminParams.ajaxNonce
		};

		jQuery.post(ajaxurl, data, function(response) {
		});
	});
};

YpmAdminJs.prototype.fixedPositionSelection = function() {
	var fixedPossitionEl = jQuery(".js-ypm-fixed-position-style");
	var fixPosition = jQuery(".js-ypm-fixed-position");
	var visitedColor = "rgba(33, 150, 243,0.5)";
	var hoverColor = "rgb(33, 150, 243)";
	var defaultColor = "#FFFFFF";
	var valueAttr = 'data-ypm-value';
	
	fixedPossitionEl.bind("click", function() {
		var ypmElement = jQuery(this);
		var ypmPoss = ypmElement.attr(valueAttr);
		fixedPossitionEl.css("backgroundColor", defaultColor);
		jQuery(this).css("backgroundColor", visitedColor);
		fixPosition.val(ypmPoss);
	});
	fixedPossitionEl.bind("mouseover", function() {
		fixedPossitionEl.css("backgroundColor", defaultColor);
		jQuery(this).css("backgroundColor", hoverColor);
		fixedPossitionEl.each(function() {
			if (jQuery(this).attr(valueAttr) == fixPosition.val())
				jQuery(this).css("backgroundColor", visitedColor);
		});
	});
	fixedPossitionEl.bind("mouseout", function() {
		if (fixedPossitionEl.attr(valueAttr) !== fixPosition.val() || fixPosition.val() == 1) {
			jQuery(this).css("backgroundColor", defaultColor);
		}
		fixedPossitionEl.each(function() {
			if (jQuery(this).attr(valueAttr) == fixPosition.val()) {
				jQuery(this).css("backgroundColor", visitedColor);
			}
		});
	});
	if (fixPosition.val() != '') {
		fixedPossitionEl.each(function() {
			if (jQuery(this).attr(valueAttr) == fixPosition.val()) {
				jQuery(this).css("backgroundColor", visitedColor);
			}
		});
	}
};

YpmAdminJs.openPopupByHref = function (href) {
    jQuery.yrmcolorbox({
        html: false,
        inline: true,
        className: 'yrmcolorbox1',
        opacity: "0.8",
        innerWidth: "480px",
        innerHeight: "320px",
        href: href,
        onOpen: function() {
            jQuery("#yrmcboxOverlay").addClass("yrmcboxOverlayBg");
        }
    })
};

jQuery(document).ready(function() {
	var obj = new YpmAdminJs();
});


/*Conditions builder*/
function YpmConditionBuilder() {
}

YpmConditionBuilder.prototype.init = function() {
	this.conditionsBuilder();
	this.select2();
};

YpmConditionBuilder.prototype.select2 = function() {
	var select2 = jQuery('.js-ypm-select');

	if(!select2.length) {
		return false;
	}
	select2.each(function() {
		var type = jQuery(this).data('select-type');

		var options = {
			width: '100%'
		};

		if (type == 'ajax') {
			options = jQuery.extend(options, {
				minimumInputLength: 1,
				ajax: {
					url: ajaxurl,
					dataType: 'json',
					delay: 250,
					type: "POST",
					data: function(params) {

						var searchKey = jQuery(this).attr('data-value-param');
						var postType = jQuery(this).attr('data-post-type');

						return {
							action: 'ypm_select2_search_data',
							nonce_ajax: YpmAdminParams.nonce,
							postType: postType,
							searchTerm: params.term,
							searchKey: searchKey
						};
					},
					processResults: function(data) {
						return {
							results: jQuery.map(data.items, function(item) {

								return {
									text: item.text,
									id: item.id
								}

							})
						};
					}
				}
			});
		}

		jQuery(this).select2(options);
	});
};

YpmConditionBuilder.prototype.conditionsBuilder = function() {
	this.conditionsBuilderEdit();
	this.conditionsBuilderAdd();
	this.conditionsBuilderSetting();
	this.conditionsBuilderDelte();
};

YpmConditionBuilder.prototype.conditionsBuilderSetting = function() {
	var settings = jQuery('.ypm-condition-settings');

	if (!settings) {
		return false;
	}

	settings.bind('click', function(e) {
		e.stopPropagation();
		var conditionsId = parseInt(jQuery(this).data('condition-id'));
		var href = '#ypm-setting-'+conditionsId;
		YpmAdminJs.openPopupByHref(href);
	});
};

YpmConditionBuilder.prototype.conditionsBuilderAdd = function() {
	var params = jQuery('.ypm-condition-add');

	if(!params.length) {
		return false;
	}
	var that = this;
	params.bind('click', function() {
		var currentWrapper = jQuery(this).parents('.ypm-condion-wrapper').first();
		var selectedParams = currentWrapper.find('.js-conditions-param').val();

		that.addViaAjax(selectedParams, currentWrapper);
	});
};

YpmConditionBuilder.prototype.conditionsBuilderDelte = function() {
	var params = jQuery('.ypm-condition-delete');

	if(!params.length) {
		return false;
	}

	params.bind('click', function() {
		var currentWrapper = jQuery(this).parents('.ypm-condion-wrapper').first();

		currentWrapper.remove();
	});
};

YpmConditionBuilder.prototype.conditionsBuilderEdit = function() {
	var params = jQuery('.js-conditions-param');

	if(!params.length) {
		return false;
	}
	var that = this;
	params.bind('change', function() {
		var selectedParams = jQuery(this).val();
		var currentWrapper = jQuery(this).parents('.ypm-condion-wrapper').first();

		that.changeViaAjax(selectedParams, currentWrapper);
	});
};

YpmConditionBuilder.prototype.addViaAjax = function(selectedParams, currentWrapper) {
	var conditionId = parseInt(currentWrapper.data('condition-id'))+1;
	var conditionsClassName = currentWrapper.parent().data('child-class');

	var that = this;

	var data = {
		action: 'ypm_add_conditions_row',
		nonce: YpmAdminParams.nonce,
		conditionId: conditionId,
		conditionsClassName: conditionsClassName,
		selectedParams: selectedParams,
		beforeSend: function () {
			that.beforeSend(conditionId);
		}
	};

	jQuery.post(ajaxurl, data, function(response) {
		currentWrapper.after(response);
		that.afterSend(conditionId);
		that.init();
	});
};

YpmConditionBuilder.prototype.changeViaAjax = function(selectedParams, currentWrapper) {
	var conditionId = currentWrapper.data('condition-id');
	var conditionsClassName = currentWrapper.parent().data('child-class');

	var that = this;

	var data = {
		action: 'ypm_edit_conditions_row',
		nonce: YpmAdminParams.nonce,
		conditionId: conditionId,
		conditionsClassName: conditionsClassName,
		selectedParams: selectedParams,
		beforeSend: function () {
			that.beforeSend(conditionId);
		}
	};

	jQuery.post(ajaxurl, data, function(response) {
		currentWrapper.replaceWith(response);
		that.afterSend(conditionId);
		that.init();
	});
};

YpmConditionBuilder.prototype.beforeSend = function(conditionId) {
	jQuery('.ypm-condition-delete, .ypm-condition-add').attr('disabled','disabled');
};

YpmConditionBuilder.prototype.afterSend = function(conditionId) {
	jQuery('.ypm-condition-delete, .ypm-condition-add').removeAttr('disabled');
};

jQuery(document).ready(function() {
	var obj = new YpmConditionBuilder();
	obj.init();
});