<?php
namespace YpmPopup;

class Filters
{
	public function __construct()
	{
		$this->init();
	}

	public function init()
	{
		add_filter('ypmRenderContent', array($this, 'renderContent'), 1, 2);
		add_filter('ypmSavedData', array($this, 'filterSavedData'), 1, 1);
	}

	public function filterSavedData($savedData)
	{
		if ($savedData === false) {
			return $savedData;
		}
		$needToCheckSaved = array(
			'ypm-events-settings'
		);
		$getDefaultData = function ($optionName) {
			global $YpmDefaults;

			foreach($YpmDefaults as $option) {
				if($option['name'] == $optionName) {
					return $option['defaultValue'];
				}
			}
		};
		foreach ($needToCheckSaved as $optionName) {
			if (!isset($savedData[$optionName])) {
				$savedData[$optionName] = $getDefaultData($optionName);
			}
		}

		return $savedData;
	}

	public function renderContent($content, $typeObj)
	{
		$options = $typeObj->getOptions();

		if (!empty($options['ypm-custom-css'])) {
			$content .= "<style type='text/css'>".$options['ypm-custom-css']."</style>";
		}
		if (!empty($options['ypm-custom-js'])) {
			$content .= "<script type='text/javascript'>".$options['ypm-custom-js']."</script>";
		}

		return $content;
	}
}