<?php
namespace YpmPopup;
use \YpmShowReviewNotice;

class Installer
{
	public static function createTables($blogsId)
	{
		global $wpdb;
		$ycfContactFormFields = "CREATE TABLE IF NOT EXISTS ". $wpdb->prefix.$blogsId."ypm_contact_form_fields (
			`field_id` int(11) NOT NULL AUTO_INCREMENT,
			`form_id` int(11) NOT NULL,
			`fields_data` TEXT NOT NULL,
			PRIMARY KEY (field_id)
			)  ENGINE=InnoDB DEFAULT CHARSET=utf8; ";

		$wpdb->query($ycfContactFormFields);
	}

	public static function install()
	{
		$obj = new self();
		YpmShowReviewNotice::setInitialDates();
		$obj->createTables("");
		if(is_multisite()) {
			$sites = wp_get_sites();
			foreach($sites as $site) {
				$blogsId = $site['blog_id']."_";
				$obj->createTables($blogsId);
			}
		}
	}

	public static function uninstall()
	{
		$obj = new self();
		YpmShowReviewNotice::deleteInitialDates();
		$obj->uninstallTables("");
		if(is_multisite()) {
			$sites = wp_get_sites();
			foreach($sites as $site) {
				$blogsId = $site['blog_id']."_";
				$obj->uninstallTables($blogsId);
			}
		}
	}

	public function uninstallTables($blogsId)
	{
		global $wpdb;
		$ycfContactFormTable = $wpdb->prefix.$blogsId.'ypm_contact_form_fields';
		$ycfContactFormSql = "DROP TABLE ". $ycfContactFormTable;
		$wpdb->query($ycfContactFormSql);
	}
}