<?php

class YpmAdminHelper
{
	public static function copyClipboard($postId, $shortCodeName, $eventName = '')
	{
		$id = $postId.'-'.$eventName;
		return '<div class="ypm-tooltip">
					<span class="ypm-tooltiptext" id="ypm-tooltip-'.$id.'">'.
			__('Copy to clipboard', YPM_POPUP_TEXT_DOMAIN).'</span>
					
					<input onfocus="this.select();" readonly="" value=\''.$shortCodeName.'\' data-id="'.$id.'" class="large-text code ypm-shortcode-input ypm-shortcode-input-'.$id.'" id="ypm-shortcode-input-'.$id.'" type="text">
				</div>';
	}

	public static function selectBox($data = array(), $selectedValue = array(), $attrs = array())
	{
		$attrString = self::formatHTMLAttrStr($attrs);
		$selected = '';

		$selectBox = '<select '.$attrString.'>';
		if (!empty($data)) {
			foreach ($data as $value => $label) {

				/*When is multiselect*/
				if(is_array($selectedValue)) {
					$isSelected = in_array($value, $selectedValue);
					if($isSelected) {
						$selected = 'selected';
					}
				}
				else if($selectedValue == $value) {
					$selected = 'selected';
				}
				else if(is_array($value) && in_array($selectedValue, $value)) {
					$selected = 'selected';
				}

				$selectBox .= '<option value="'.$value.'" '.$selected.'>'.$label.'</option>';
				$selected = '';
			}
		}

		$selectBox .= '</select>';

		return $selectBox;
	}

	public static function inputElement($currentData, $savedValue, $fieldAttributes)
	{
	    $fieldAttributes['value'] = isset($savedValue) ? $savedValue : @$fieldAttributes['value'];
		$attrString = self::formatHTMLAttrStr($fieldAttributes);

		return "<input $attrString>";
	}

	public static function switchElement($currentData, $savedValue, $fieldAttributes)
    {
        $value = !empty($savedValue) ? 'checked': '';
        $attrString = self::formatHTMLAttrStr($fieldAttributes);
        ob_start();
        ?>
            <label class="ypm-switch">
                <input <?php echo $attrString; ?><?php echo $value; ?>>
                <span class="ypm-slider ypm-round"></span>
            </label>
        <?php
        $content = ob_get_contents();
        ob_end_clean();

        return $content;
    }

	public static function getPostTypeData($args = array())
	{
		$query = self::getQueryDataByArgs($args);

		$posts = array();
		foreach ($query->posts as $post) {
			$posts[$post->ID] = $post->post_title;
		}

		return $posts;
	}

	public static function getQueryDataByArgs($args = array())
	{
		$defaultArgs = array(
			'offset'           =>  0,
			'orderby'          => 'date',
			'order'            => 'DESC',
			'post_status'      => 'publish',
			'suppress_filters' => true,
			'post_type'        => 'post',
			'posts_per_page'   => 1000
		);

		$args = wp_parse_args($args, $defaultArgs);
		$query = new WP_Query($args);

		return $query;
	}

	public static function getCurrentPostType()
	{
		global $post_type;
		global $post;
		$currentPostType = '';

		if (is_object($post)) {
			$currentPostType = $post->post_type;
		}

		// in some themes global $post returns null
		if (empty($currentPostType)) {
			$currentPostType = $post_type;
		}

		if (empty($currentPostType) && !empty($_GET['post'])) {
			$currentPostType = get_post_type($_GET['post']);
		}

		return $currentPostType;
	}

	public static function serializeData($data = array())
	{
		$serializedData = serialize($data);

		return $serializedData;
	}

	public static function updateOption($optionKey, $optionValue)
	{
		update_option($optionKey, $optionValue);
	}

	public static function getOption($optionKey, $default = false)
	{
		return get_option($optionKey, $default);
	}

	public static function deleteOption($optionKey)
	{
		delete_option($optionKey);
	}

	public static function formatHTMLAttrStr($attrs)
	{
		$attrString = '';
		if(!empty($attrs) && isset($attrs)) {

			foreach ($attrs as $attrName => $attrValue) {
				$attrString .= ''.$attrName.'="'.$attrValue.'" ';
			}
		}

		return $attrString;
	}
}